package jdk.management.resource.internal.inst;

import jdk.internal.instrumentation.InstrumentationMethod;
import jdk.management.resource.ResourceRequest;
import jdk.management.resource.ResourceRequestDeniedException;
import java.io.IOException;
import jdk.management.resource.internal.ResourceIdImpl;
import jdk.management.resource.internal.ApproverGroup;
import java.net.Socket;
import jdk.internal.instrumentation.InstrumentationTarget;

@InstrumentationTarget("sun.security.ssl.SSLServerSocketImpl")
final class SSLServerSocketImplRMHooks
{
    SSLServerSocketImplRMHooks() {
    }
    
    @InstrumentationMethod
    public Socket accept() throws IOException {
        long request = 0L;
        long n = 0L;
        Socket accept = null;
        ResourceIdImpl of = null;
        ResourceRequest approver = null;
        try {
            accept = this.accept();
            n = 1L;
            approver = ApproverGroup.SOCKET_OPEN_GROUP.getApprover(accept);
            of = ResourceIdImpl.of(accept.getLocalAddress());
            try {
                request = approver.request(1L, of);
                if (request < 1L) {
                    try {
                        accept.close();
                    }
                    catch (IOException ex) {}
                    throw new IOException("Resource limited: too many open sockets");
                }
            }
            catch (ResourceRequestDeniedException cause) {
                try {
                    accept.close();
                }
                catch (IOException ex2) {}
                throw new IOException("Resource limited: too many open sockets", cause);
            }
            n = 1L;
        }
        finally {
            if (approver != null) {
                approver.request(-(request - n), of);
            }
        }
        return accept;
    }
}
